package com.example.framelayoutsample;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.Animation.AnimationListener;
import android.widget.Button;
import android.widget.ImageView;

public class MainActivity extends Activity implements OnClickListener{
	
	private int imageIndex = 0;
	private ImageView mImgView01;
	private ImageView mImgView02;
	private ImageView mImgView03;
	private Button mBtnPrev;
	private Button mBtnNext;
	
	private Animation mTranslateLeftAnim;
	private Animation mTranslateRightAnim;
	
	private int mDirect = 0; // 0:Prev ư Ŭ, 1:next ư Ŭ
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		mImgView01 = (ImageView)findViewById(R.id.imageView1);
		mImgView02 = (ImageView)findViewById(R.id.imageView2);
		mImgView03 = (ImageView)findViewById(R.id.imageView3);
		
		mBtnPrev = (Button)findViewById(R.id.btnPrev);
		mBtnNext = (Button)findViewById(R.id.btnNext);
		
		mBtnPrev.setOnClickListener(this);
		mBtnNext.setOnClickListener(this);
		
		// ִϸ̼ ɼ  
		mTranslateLeftAnim = AnimationUtils.loadAnimation(this, R.anim.translate_left);
		mTranslateRightAnim = AnimationUtils.loadAnimation(this, R.anim.translate_right);
		
		// ִϸ̼ǿ   
		PageAnimationListener animListener = new PageAnimationListener();
		
		mTranslateLeftAnim.setAnimationListener(animListener);
		mTranslateRightAnim.setAnimationListener(animListener);
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btnNext:
			mDirect = 1;
			if (imageIndex < 2 ) {
				imageIndex ++;
				changeImage();
			}
			
			break;
			
		case R.id.btnPrev:
			mDirect = 0;
			if (imageIndex > 0){
				imageIndex --;
				changeImage();
			}
			break;

		default:
			break;
		}
	}
	
	private void changeImage(){
		if (imageIndex == 0) {
			mImgView01.bringToFront();
			mImgView01.setVisibility(View.VISIBLE);
			if (mDirect == 0) {
				mImgView01.startAnimation(mTranslateRightAnim);
				
			}else{
				mImgView01.startAnimation(mTranslateLeftAnim);
			}
			
		}else if (imageIndex == 1){
			mImgView02.bringToFront();
			mImgView02.invalidate();
			mImgView02.setVisibility(View.VISIBLE);
			if (mDirect == 0) {
				mImgView02.startAnimation(mTranslateRightAnim);
			}else{
				mImgView02.startAnimation(mTranslateLeftAnim);
			}
			
		}else if (imageIndex == 2){
			mImgView03.bringToFront();
			mImgView03.setVisibility(View.VISIBLE);
			if (mDirect == 0) {
				mImgView03.startAnimation(mTranslateRightAnim);
			}else{
				mImgView03.startAnimation(mTranslateLeftAnim);
			}
		}
		setViewInvalidate(mImgView01, mImgView02, mImgView03);
	}
	
	// Ķͷ Ѿ view  ٽ ׷ش
	private void setViewInvalidate(View...views){
		for(View v:views){
			v.invalidate();
		}
	}
	
	public class PageAnimationListener implements AnimationListener {

		public void onAnimationEnd(Animation arg0) {
			// ִϸ̼  Ǿ    ʰ Ѵ. 
			if (imageIndex == 0) {
				mImgView02.setVisibility(View.INVISIBLE);
				mImgView03.setVisibility(View.INVISIBLE);
				
			}else if (imageIndex == 1){
				mImgView01.setVisibility(View.INVISIBLE);
				mImgView03.setVisibility(View.INVISIBLE);
				
			}else if (imageIndex == 2){
				mImgView01.setVisibility(View.INVISIBLE);
				mImgView02.setVisibility(View.INVISIBLE);
				
			}
			
		}

		public void onAnimationRepeat(Animation arg0) {
			// TODO Auto-generated method stub

		}

		public void onAnimationStart(Animation arg0) {
			// TODO Auto-generated method stub

		}

	}

}
